#!/bin/bash

if [[ $# -ne 3 ]]; then
  echo "usage: ddns-reg.sh <ddns-key> <name> <ip>"
  exit 1;
fi

ddns_key=$1
name=$2
myip=$3

raddr=`echo $myip | awk -F. '{print $4"."$3"."$2"."$1}'`
rzone=`echo $myip | awk -F. '{print $3"."$2"."$1}'`

cat <<EOF > /tmp/nsdata
server ns0.portal.{{ domain }}
zone portal.{{ domain }}

update delete $name.portal.{{ domain }}. A
update add $name.portal.{{ domain }}. 86400 A $myip

zone $rzone.in-addr.arpa
update delete $raddr.in-addr.arpa. PTR
update add $raddr.in-addr.arpa. 86400 PTR $name.portal.{{ domain }}.

show
send
EOF

nsupdate -k /opt/merge/ddns-key /tmp/nsdata
